      program adi
      implicit none
      integer nn, stdout
      real dt, h
      parameter (nn=256)
      parameter (dt=0.1)
      parameter (h=0.2)
      parameter (stdout=6)
      common /pghpf_0/pghpf_0, /pghpf_1/pghpf_1, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno, /pghpf_0l/pghpf_0l
      integer pghpf_0, pghpf_1, pghpf_lineno, pghpf_0l(8)
      character*1 pghpf_0c
      integer i, j, itime, ntime, hpf_np$, z_e_82, z__io, i$i, i$i1, 
     +i$i2, i$i3, i$i4, i$i5, i$i6, procs$d(1), i$l, i$u, i$l1, i$u1, 
     +i$l2, i$u2, i$l3, i$u3, i$l4, i$u4, i$l5, i$u5, i$l6, i$u6, i$l7, 
     +i$u7, i$l8, i$u8, i$l9, i$u9, i$l10, i$u10, tplate$tl$d(1), 
     +psi$f$d(1), psi$f$d1(1), l$b, u$b, l$b1, u$b1, tplate$tl1$d(1), 
     +zeta$f$d(1), zeta$f$d1(1), l$b2, u$b2, l$b3, u$b3, tplate$tl2$d(1)
     +, rhs$f$d(1), rhs$f$d1(1), l$b4, u$b4, l$b5, u$b5, tplate$tl3$d(1)
     +, psi$f1$d(1), psi$f1$d1(1), l$b6, u$b6, l$b7, u$b7, tplate$tl4$d(
     +1), zeta$f1$d(1), zeta$f1$d1(1), l$b8, u$b8, l$b9, u$b9, 
     +tplate$tl5$d(1), rhs$f1$d(1), rhs$f1$d1(1), l$b10, u$b10, l$b11, 
     +u$b11, tplate$tl5$d1(1), wspace$d(1), wspace$d1(1), l$b12, u$b12, 
     +l$b13, u$b13
      real alpha, h2, beta(1), psi(1), zeta(1), rhs(1), wspace(1), psi$f
     +(1), zeta$f(1), rhs$f(1), psi$f1(1), zeta$f1(1), rhs$f1(1)
      integer beta$p, psi$p, zeta$p, rhs$p, wspace$p, procs$dp, psi$f$p
     +, zeta$f$p, rhs$f$p, psi$f1$p, zeta$f1$p, rhs$f1$p, tplate$tl$dp, 
     +psi$f$dp, psi$f$dp1, tplate$tl1$dp, zeta$f$dp, zeta$f$dp1, 
     +tplate$tl2$dp, rhs$f$dp, rhs$f$dp1, tplate$tl3$dp, psi$f1$dp, 
     +psi$f1$dp1, tplate$tl4$dp, zeta$f1$dp, zeta$f1$dp1, tplate$tl5$dp
     +, rhs$f1$dp, rhs$f1$dp1, tplate$tl5$dp1, wspace$dp, wspace$dp1
      integer pgf90io_fmtw_init, pgf90io_fmt_write, pgf90io_fmtw_end, 
     +pghpf_nprocs, pghpf_newproc
      external tridiag_psi, find_rhs_psi
      integer z__fmt1001(13)
      data z__fmt1001/-5,14,'Stat','us: ','iTim','e=  ',-21,0,6,0,1,-1,0
     +/
      data pghpf_0l /833907066,1615702195,876526039,-615119345,1,
     +1261038733,0,-1716691668/
      call pghpf_init(0)
      call pghpf_function_entry(5,132,'adi','main.f90')
      hpf_np$ = pghpf_nprocs()
      z_e_82 = hpf_np$
      procs$dp = pghpf_newproc(1,hpf_np$)
      call pghpf_ptr_offset(procs$dp,procs$dp,procs$d,25)
      call pghpf_template(tplate$tl5$dp1,1,1280,procs$d(procs$dp),0,0,1,
     +256)
      call pghpf_ptr_offset(tplate$tl5$dp1,tplate$tl5$dp1,tplate$tl5$d1,
     +25)
      call pghpf_template(wspace$dp,2,4096,tplate$tl5$d1(tplate$tl5$dp1)
     +,0,1,1,1,0,0,1,256,1,256)
      call pghpf_ptr_offset(wspace$dp,wspace$dp,wspace$d,25)
      call pghpf_instance(wspace$dp1,wspace$d(wspace$dp),27,4,1,4,4)
      call pghpf_ptr_offset(wspace$dp1,wspace$dp1,wspace$d1,25)
      call pghpf_allobnds(wspace$d1(wspace$dp1),l$b12,u$b12,l$b13,u$b13)
      call pgf90_alloc((u$b12-l$b12+1)*(u$b13-l$b13+1),27,pghpf_0,
     +pghpf_0,beta$p,beta)
      call pgf90_alloc((u$b12-l$b12+1)*(u$b13-l$b13+1),27,pghpf_0,
     +pghpf_0,psi$p,psi)
      call pgf90_alloc((u$b12-l$b12+1)*(u$b13-l$b13+1),27,pghpf_0,
     +pghpf_0,zeta$p,zeta)
      call pgf90_alloc((u$b12-l$b12+1)*(u$b13-l$b13+1),27,pghpf_0,
     +pghpf_0,rhs$p,rhs)
      call pgf90_alloc((u$b12-l$b12+1)*(u$b13-l$b13+1),27,pghpf_0,
     +pghpf_0,wspace$p,wspace)
      pghpf_lineno = 88
      call pghpf_line_entry()
      h2 = 0.2 * 0.2
      pghpf_lineno = 89
      call pghpf_line_entry()
      alpha = h2 * 2.0 / 0.1
      pghpf_lineno = 90
      call pghpf_line_entry()
      ntime = 10
      pghpf_lineno = 93
      call pghpf_line_entry()
      call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l,i$u
     +)
!     forall (i$i=i$l:i$u:1, i$i1=1:256:1) rhs((u$b12-l$b12+1)*(i$i-
!    +l$b13)+i$i1-l$b12+rhs$p) = 1.0
      do i$i = i$l, i$u
         do i$i1 = 1, 256
            rhs((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+rhs$p) = 1.0
         enddo
      enddo
      pghpf_lineno = 94
      call pghpf_line_entry()
      call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l1,
     +i$u1)
!     forall (i$i=i$l1:i$u1:1, i$i1=1:256:1) wspace((u$b12-l$b12+1)*(i$i
!    +-l$b13)+i$i1-l$b12+wspace$p) = 0.0
      do i$i = i$l1, i$u1
         do i$i1 = 1, 256
            wspace((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+wspace$p) = 
     +0.0
         enddo
      enddo
      pghpf_lineno = 95
      call pghpf_line_entry()
      call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l2,
     +i$u2)
!     forall (i$i=i$l2:i$u2:1, i$i1=1:256:1) psi((u$b12-l$b12+1)*(i$i-
!    +l$b13)+i$i1-l$b12+psi$p) = 5.0
      do i$i = i$l2, i$u2
         do i$i1 = 1, 256
            psi((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+psi$p) = 5.0
         enddo
      enddo
      pghpf_lineno = 96
      call pghpf_line_entry()
      call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,2,255,1,i$l3,
     +i$u3)
!     forall (i$i=i$l3:i$u3:1, i$i1=2:255:1) psi((u$b12-l$b12+1)*(i$i-
!    +l$b13)+i$i1-l$b12+psi$p) = 2.0
      do i$i = i$l3, i$u3
         do i$i1 = 2, 255
            psi((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+psi$p) = 2.0
         enddo
      enddo
      pghpf_lineno = 99
      call pghpf_line_entry()
      call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l4,
     +i$u4)
!     forall (i$i=i$l4:i$u4:1, i$i1=1:256:1) zeta((u$b12-l$b12+1)*(i$i-
!    +l$b13)+i$i1-l$b12+zeta$p) = 0.0
      do i$i = i$l4, i$u4
         do i$i1 = 1, 256
            zeta((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+zeta$p) = 0.0
         enddo
      enddo
      pghpf_lineno = 102
      call pghpf_line_entry()
      continue
      do itime = 1, ntime
         pghpf_lineno = 105
         call pghpf_line_entry()
         call tridiag_psi(alpha,beta(beta$p),rhs(rhs$p),psi(psi$p),
     +wspace(wspace$p),256,pghpf_1,wspace$d1(wspace$dp1),wspace$d1(
     +wspace$dp1),wspace$d1(wspace$dp1),wspace$d1(wspace$dp1),pghpf_1)
         pghpf_lineno = 106
         call pghpf_line_entry()
         call find_rhs_psi(alpha,h2,psi(psi$p),zeta(zeta$p),rhs(rhs$p),
     +256,pghpf_1,pghpf_1,wspace$d1(wspace$dp1),wspace$d1(wspace$dp1),
     +wspace$d1(wspace$dp1),pghpf_1)
         call pghpf_template(tplate$tl$dp,1,1280,procs$d(procs$dp),0,0,1
     +,256)
         call pghpf_ptr_offset(tplate$tl$dp,tplate$tl$dp,tplate$tl$d,25)
         call pghpf_template(psi$f$dp,2,4096,tplate$tl$d(tplate$tl$dp),0
     +,1,1,1,0,0,1,256,1,256)
         call pghpf_ptr_offset(psi$f$dp,psi$f$dp,psi$f$d,25)
         call pghpf_instance(psi$f$dp1,psi$f$d(psi$f$dp),27,4,1,4,4)
         call pghpf_ptr_offset(psi$f$dp1,psi$f$dp1,psi$f$d1,25)
         pghpf_lineno = 108
         call pghpf_line_entry()
         call pghpf_allobnds(psi$f$d1(psi$f$dp1),l$b,u$b,l$b1,u$b1)
         call pgf90_alloc((u$b-l$b+1)*(u$b1-l$b1+1),27,pghpf_0,pghpf_0,
     +psi$f$p,psi$f)
         call pghpf_permute_section(psi$f(psi$f$p),psi(psi$p),psi$f$d1(
     +psi$f$dp1),wspace$d1(wspace$dp1),2,1)
         call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l5
     +,i$u5)
!        forall (i$i=i$l5:i$u5:1, i$i1=1:256:1) psi((u$b12-l$b12+1)*(i$i
!    +-l$b13)+i$i1-l$b12+psi$p) = psi$f((u$b-l$b+1)*(i$i-l$b1)+i$i1-l$b+
!    +psi$f$p)
         do i$i = i$l5, i$u5
            do i$i1 = 1, 256
               psi((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+psi$p) = psi$f
     +((u$b-l$b+1)*(i$i-l$b1)+i$i1-l$b+psi$f$p)
            enddo
         enddo
         call pghpf_freen(3,tplate$tl$d(tplate$tl$dp),psi$f$d(psi$f$dp),
     +psi$f$d1(psi$f$dp1))
         call pgf90_deallocate(psi$f(psi$f$p),pghpf_0)
         call pghpf_template(tplate$tl1$dp,1,1280,procs$d(procs$dp),0,0,
     +1,256)
         call pghpf_ptr_offset(tplate$tl1$dp,tplate$tl1$dp,tplate$tl1$d,
     +25)
         call pghpf_template(zeta$f$dp,2,4096,tplate$tl1$d(tplate$tl1$dp
     +),0,1,1,1,0,0,1,256,1,256)
         call pghpf_ptr_offset(zeta$f$dp,zeta$f$dp,zeta$f$d,25)
         call pghpf_instance(zeta$f$dp1,zeta$f$d(zeta$f$dp),27,4,1,4,4)
         call pghpf_ptr_offset(zeta$f$dp1,zeta$f$dp1,zeta$f$d1,25)
         pghpf_lineno = 109
         call pghpf_line_entry()
         call pghpf_allobnds(zeta$f$d1(zeta$f$dp1),l$b2,u$b2,l$b3,u$b3)
         call pgf90_alloc((u$b2-l$b2+1)*(u$b3-l$b3+1),27,pghpf_0,pghpf_0
     +,zeta$f$p,zeta$f)
         call pghpf_permute_section(zeta$f(zeta$f$p),zeta(zeta$p),
     +zeta$f$d1(zeta$f$dp1),wspace$d1(wspace$dp1),2,1)
         call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l6
     +,i$u6)
!        forall (i$i=i$l6:i$u6:1, i$i1=1:256:1) zeta((u$b12-l$b12+1)*(
!    +i$i-l$b13)+i$i1-l$b12+zeta$p) = zeta$f((u$b2-l$b2+1)*(i$i-l$b3)+
!    +i$i1-l$b2+zeta$f$p)
         do i$i = i$l6, i$u6
            do i$i1 = 1, 256
               zeta((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+zeta$p) = 
     +zeta$f((u$b2-l$b2+1)*(i$i-l$b3)+i$i1-l$b2+zeta$f$p)
            enddo
         enddo
         call pghpf_freen(3,tplate$tl1$d(tplate$tl1$dp),zeta$f$d(
     +zeta$f$dp),zeta$f$d1(zeta$f$dp1))
         call pgf90_deallocate(zeta$f(zeta$f$p),pghpf_0)
         call pghpf_template(tplate$tl2$dp,1,1280,procs$d(procs$dp),0,0,
     +1,256)
         call pghpf_ptr_offset(tplate$tl2$dp,tplate$tl2$dp,tplate$tl2$d,
     +25)
         call pghpf_template(rhs$f$dp,2,4096,tplate$tl2$d(tplate$tl2$dp)
     +,0,1,1,1,0,0,1,256,1,256)
         call pghpf_ptr_offset(rhs$f$dp,rhs$f$dp,rhs$f$d,25)
         call pghpf_instance(rhs$f$dp1,rhs$f$d(rhs$f$dp),27,4,1,4,4)
         call pghpf_ptr_offset(rhs$f$dp1,rhs$f$dp1,rhs$f$d1,25)
         pghpf_lineno = 110
         call pghpf_line_entry()
         call pghpf_allobnds(rhs$f$d1(rhs$f$dp1),l$b4,u$b4,l$b5,u$b5)
         call pgf90_alloc((u$b4-l$b4+1)*(u$b5-l$b5+1),27,pghpf_0,pghpf_0
     +,rhs$f$p,rhs$f)
         call pghpf_permute_section(rhs$f(rhs$f$p),rhs(rhs$p),rhs$f$d1(
     +rhs$f$dp1),wspace$d1(wspace$dp1),2,1)
         call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l7
     +,i$u7)
!        forall (i$i=i$l7:i$u7:1, i$i1=1:256:1) rhs((u$b12-l$b12+1)*(i$i
!    +-l$b13)+i$i1-l$b12+rhs$p) = rhs$f((u$b4-l$b4+1)*(i$i-l$b5)+i$i1-
!    +l$b4+rhs$f$p)
         do i$i = i$l7, i$u7
            do i$i1 = 1, 256
               rhs((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+rhs$p) = rhs$f
     +((u$b4-l$b4+1)*(i$i-l$b5)+i$i1-l$b4+rhs$f$p)
            enddo
         enddo
         call pghpf_freen(3,tplate$tl2$d(tplate$tl2$dp),rhs$f$d(rhs$f$dp
     +),rhs$f$d1(rhs$f$dp1))
         call pgf90_deallocate(rhs$f(rhs$f$p),pghpf_0)
         pghpf_lineno = 113
         call pghpf_line_entry()
         call tridiag_psi(alpha,beta(beta$p),rhs(rhs$p),psi(psi$p),
     +wspace(wspace$p),256,pghpf_1,wspace$d1(wspace$dp1),wspace$d1(
     +wspace$dp1),wspace$d1(wspace$dp1),wspace$d1(wspace$dp1),pghpf_1)
         pghpf_lineno = 114
         call pghpf_line_entry()
         call find_rhs_psi(alpha,h2,psi(psi$p),zeta(zeta$p),rhs(rhs$p),
     +256,pghpf_1,pghpf_1,wspace$d1(wspace$dp1),wspace$d1(wspace$dp1),
     +wspace$d1(wspace$dp1),pghpf_1)
         call pghpf_template(tplate$tl3$dp,1,1280,procs$d(procs$dp),0,0,
     +1,256)
         call pghpf_ptr_offset(tplate$tl3$dp,tplate$tl3$dp,tplate$tl3$d,
     +25)
         call pghpf_template(psi$f1$dp,2,4096,tplate$tl3$d(tplate$tl3$dp
     +),0,1,1,1,0,0,1,256,1,256)
         call pghpf_ptr_offset(psi$f1$dp,psi$f1$dp,psi$f1$d,25)
         call pghpf_instance(psi$f1$dp1,psi$f1$d(psi$f1$dp),27,4,1,4,4)
         call pghpf_ptr_offset(psi$f1$dp1,psi$f1$dp1,psi$f1$d1,25)
         pghpf_lineno = 116
         call pghpf_line_entry()
         call pghpf_allobnds(psi$f1$d1(psi$f1$dp1),l$b6,u$b6,l$b7,u$b7)
         call pgf90_alloc((u$b6-l$b6+1)*(u$b7-l$b7+1),27,pghpf_0,pghpf_0
     +,psi$f1$p,psi$f1)
         call pghpf_permute_section(psi$f1(psi$f1$p),psi(psi$p),
     +psi$f1$d1(psi$f1$dp1),wspace$d1(wspace$dp1),2,1)
         call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l8
     +,i$u8)
!        forall (i$i=i$l8:i$u8:1, i$i1=1:256:1) psi((u$b12-l$b12+1)*(i$i
!    +-l$b13)+i$i1-l$b12+psi$p) = psi$f1((u$b6-l$b6+1)*(i$i-l$b7)+i$i1-
!    +l$b6+psi$f1$p)
         do i$i = i$l8, i$u8
            do i$i1 = 1, 256
               psi((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+psi$p) = 
     +psi$f1((u$b6-l$b6+1)*(i$i-l$b7)+i$i1-l$b6+psi$f1$p)
            enddo
         enddo
         call pghpf_freen(3,tplate$tl3$d(tplate$tl3$dp),psi$f1$d(
     +psi$f1$dp),psi$f1$d1(psi$f1$dp1))
         call pgf90_deallocate(psi$f1(psi$f1$p),pghpf_0)
         call pghpf_template(tplate$tl4$dp,1,1280,procs$d(procs$dp),0,0,
     +1,256)
         call pghpf_ptr_offset(tplate$tl4$dp,tplate$tl4$dp,tplate$tl4$d,
     +25)
         call pghpf_template(zeta$f1$dp,2,4096,tplate$tl4$d(
     +tplate$tl4$dp),0,1,1,1,0,0,1,256,1,256)
         call pghpf_ptr_offset(zeta$f1$dp,zeta$f1$dp,zeta$f1$d,25)
         call pghpf_instance(zeta$f1$dp1,zeta$f1$d(zeta$f1$dp),27,4,1,4,
     +4)
         call pghpf_ptr_offset(zeta$f1$dp1,zeta$f1$dp1,zeta$f1$d1,25)
         pghpf_lineno = 117
         call pghpf_line_entry()
         call pghpf_allobnds(zeta$f1$d1(zeta$f1$dp1),l$b8,u$b8,l$b9,u$b9
     +)
         call pgf90_alloc((u$b8-l$b8+1)*(u$b9-l$b9+1),27,pghpf_0,pghpf_0
     +,zeta$f1$p,zeta$f1)
         call pghpf_permute_section(zeta$f1(zeta$f1$p),zeta(zeta$p),
     +zeta$f1$d1(zeta$f1$dp1),wspace$d1(wspace$dp1),2,1)
         call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,i$l9
     +,i$u9)
!        forall (i$i=i$l9:i$u9:1, i$i1=1:256:1) zeta((u$b12-l$b12+1)*(
!    +i$i-l$b13)+i$i1-l$b12+zeta$p) = zeta$f1((u$b8-l$b8+1)*(i$i-l$b9)+
!    +i$i1-l$b8+zeta$f1$p)
         do i$i = i$l9, i$u9
            do i$i1 = 1, 256
               zeta((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+zeta$p) = 
     +zeta$f1((u$b8-l$b8+1)*(i$i-l$b9)+i$i1-l$b8+zeta$f1$p)
            enddo
         enddo
         call pghpf_freen(3,tplate$tl4$d(tplate$tl4$dp),zeta$f1$d(
     +zeta$f1$dp),zeta$f1$d1(zeta$f1$dp1))
         call pgf90_deallocate(zeta$f1(zeta$f1$p),pghpf_0)
         call pghpf_template(tplate$tl5$dp,1,1280,procs$d(procs$dp),0,0,
     +1,256)
         call pghpf_ptr_offset(tplate$tl5$dp,tplate$tl5$dp,tplate$tl5$d,
     +25)
         call pghpf_template(rhs$f1$dp,2,4096,tplate$tl5$d(tplate$tl5$dp
     +),0,1,1,1,0,0,1,256,1,256)
         call pghpf_ptr_offset(rhs$f1$dp,rhs$f1$dp,rhs$f1$d,25)
         call pghpf_instance(rhs$f1$dp1,rhs$f1$d(rhs$f1$dp),27,4,1,4,4)
         call pghpf_ptr_offset(rhs$f1$dp1,rhs$f1$dp1,rhs$f1$d1,25)
         pghpf_lineno = 118
         call pghpf_line_entry()
         call pghpf_allobnds(rhs$f1$d1(rhs$f1$dp1),l$b10,u$b10,l$b11,
     +u$b11)
         call pgf90_alloc((u$b10-l$b10+1)*(u$b11-l$b11+1),27,pghpf_0,
     +pghpf_0,rhs$f1$p,rhs$f1)
         call pghpf_permute_section(rhs$f1(rhs$f1$p),rhs(rhs$p),
     +rhs$f1$d1(rhs$f1$dp1),wspace$d1(wspace$dp1),2,1)
         call pghpf_localize_bounds(wspace$d1(wspace$dp1),2,1,256,1,
     +i$l10,i$u10)
!        forall (i$i=i$l10:i$u10:1, i$i1=1:256:1) rhs((u$b12-l$b12+1)*(
!    +i$i-l$b13)+i$i1-l$b12+rhs$p) = rhs$f1((u$b10-l$b10+1)*(i$i-l$b11)+
!    +i$i1-l$b10+rhs$f1$p)
         do i$i = i$l10, i$u10
            do i$i1 = 1, 256
               rhs((u$b12-l$b12+1)*(i$i-l$b13)+i$i1-l$b12+rhs$p) = 
     +rhs$f1((u$b10-l$b10+1)*(i$i-l$b11)+i$i1-l$b10+rhs$f1$p)
            enddo
         enddo
         call pghpf_freen(3,tplate$tl5$d(tplate$tl5$dp),rhs$f1$d(
     +rhs$f1$dp),rhs$f1$d1(rhs$f1$dp1))
         call pgf90_deallocate(rhs$f1(rhs$f1$p),pghpf_0)
         pghpf_lineno = 120
         call pghpf_line_entry()
         call pgf90io_src_info(120,'main.f90')
         z__io = pgf90io_fmtw_init(6,0,0,0,z__fmt1001,pghpf_0c)
         z__io = pgf90io_fmt_write(25,1,0,itime)
         z__io = pgf90io_fmtw_end()
         pghpf_lineno = 124
         call pghpf_line_entry()
      enddo
      pghpf_lineno = 131
      call pghpf_line_entry()
      call pgf90_stop(pghpf_0c)
99999 continue
      pghpf_lineno = 136
      call pghpf_line_entry()
      call pghpf_freen(4,procs$d(procs$dp),tplate$tl5$d1(tplate$tl5$dp1)
     +,wspace$d(wspace$dp),wspace$d1(wspace$dp1))
      call pgf90_deallocate(wspace(wspace$p),pghpf_0)
      call pgf90_deallocate(rhs(rhs$p),pghpf_0)
      call pgf90_deallocate(zeta(zeta$p),pghpf_0)
      call pgf90_deallocate(psi(psi$p),pghpf_0)
      call pgf90_deallocate(beta(beta$p),pghpf_0)
      call pghpf_function_exit()
      end
